#include <windows.h>
#include <cstdio>

using namespace std;

struct stHora {
    int x;
    int y;
    bool salir;
};

DWORD WINAPI MostrarHora( void* par) {
    stHora *hora = (stHora*)par;      // Recuperar el parmetro, un puntero a stHora
    SYSTEMTIME st;                    // Estructura para obtener la hora
    COORD dwPos = {hora->x, hora->y}; // Coordenadas de pantalla para mostrar hora
    int seg = 0;                      // Variable auxiliar para detectar cambio de segundo

    do {
        // Esperamos a que cambie el segundo:
        while(seg == st.wSecond) {
            GetLocalTime(&st);
            Sleep(100);
        }
        // Colocar el cursor:
        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
        // Mostrar hora:
        printf("%02d:%02d:%02d", st.wHour, st.wMinute, st.wSecond);
        // Almacenar el segundo actual:
        seg = st.wSecond;
    } while(!hora->salir); // Repetir hasta que salir sea true

    printf("\nAbandonando el hilo\n");
    return 0;
}

int main() {
    HANDLE hHora;
    HANDLE hHora2;
    stHora hora={70, 1, false};
    stHora hora2={1, 1, false};

    // Crear el hilo
    hHora = CreateThread( 0, 0, MostrarHora, (void*)&hora, 0, 0);
    hHora2 = CreateThread( 0, 0, MostrarHora, (void*)&hora2, 0, 0);

    // Esperar a que el usuario pulse una tecla, el hilo se sigue ejecutando:
    printf("Pulsa una tecla para salir");
    getchar();
    hora.salir = true;
    hora2.salir = true;

    // Dejar tiempo a que termine el hilo:
    Sleep(2000);

    // Liberar el manipulador:
    CloseHandle(hHora);
    CloseHandle(hHora2);
    return 0;
}
